﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SORTER
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        int[] array;
        string path;
        FileInfo file;

        public MainWindow()
        {
            InitializeComponent();
        }


        bool writeFile(string nameFile, int[] arraySorted)
        {

            try
            {
                string pathCopy = pathCopied(nameFile);
                using (StreamWriter sw = new StreamWriter(pathCopy, false))
                {
                    for (int i = 0; i < arraySorted.Length; ++i)
                    {
                        sw.Write(arraySorted[i] + " ");
                    }
                }
            }
            catch
            {
                MessageBox.Show("Ошибка записи");
                return false;
            }
            return true;
        }

        string pathCopied(string nameFile)
        {
            string pathCopy = file.DirectoryName + nameFile;

            if (!File.Exists(pathCopy))
            {
                File.Copy(path, pathCopy);
            }

            return pathCopy;
        }

        int[] arrayCopied()
        {
            int[] arrayCopy = new int[array.Length];
            for (int i = 0; i < arrayCopy.Length; ++i)
            {
                arrayCopy[i] = array[i];
            }
            return arrayCopy;
        }

       

        private void SortButton_Click(object sender, RoutedEventArgs e)
        {
            if(string.IsNullOrEmpty(path))
            {
                MessageBox.Show("Для сортировки нужно выбрать файл");
            }
            else
            {
                if (LinearButton.IsChecked == true)
                {
                    int[] arraySorted = sortClass.linearSelectionSort(Ascending.IsChecked, arrayCopied());
                    writeFile(@"\Линейный выбор.txt", arraySorted);
                }
                else if (minMaxButton.IsChecked == true)
                {
                    int[] arraySorted = sortClass.methodMinMax(Ascending.IsChecked, arrayCopied());
                    writeFile(@"\МинМакс.txt", arraySorted);
                }
                else if (BubbleButton.IsChecked == true)
                {
                    int[] arraySorted = sortClass.BubbleSort(Ascending.IsChecked, arrayCopied());
                    writeFile(@"\Пузырьковая сортировка.txt", arraySorted);
                }
                else if (ShuttleButton.IsChecked == true)
                {
                    int[] arraySorted = sortClass.ShuttleSort(Ascending.IsChecked, arrayCopied());
                    writeFile(@"\Челночная сортировка.txt", arraySorted);
                }
                else if (InsertionButton.IsChecked == true)
                {
                    int[] arraySorted = sortClass.InsertionSort(Ascending.IsChecked, arrayCopied());
                    writeFile(@"\Сортировка вставки.txt", arraySorted);
                }

                MessageBox.Show("Массив отсортирован, файл с ним находится рядом с выбранным файлом");
            }
        }

        private void SelectFile_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog OPF = new OpenFileDialog();
            OPF.Filter = "Файлы txt|*.txt";
            if (OPF.ShowDialog() == true)
            {
                path = OPF.FileName;
                file = new FileInfo(path);

                using (StreamReader sr = new StreamReader(OPF.FileName))
                {
                    try
                    {
                        string str = sr.ReadToEnd().Trim();
                        str = str.Replace("\n", " ");
                        str = str.Replace(",", "");
                        string[] arrayStr = str.Split(" ");

                        array = new int[arrayStr.Length];

                        for (int i = 0; i < arrayStr.Length; ++i)
                        {
                            array[i] = Convert.ToInt32(arrayStr[i]);
                        }
                    }
                    catch
                    {
                        MessageBox.Show("Файл пустой или данные не корректны");
                    }
                }
            }
        }

        private void Diagram_Click(object sender, RoutedEventArgs e)
        {
            if (sortClass.linearTime == null || sortClass.minMaxTime == null || sortClass.bubleTime == null || sortClass.shuttleTime == null || sortClass.insertionTime == null)
            {
                MessageBox.Show("Для того, чтобы построить диаграмму, нужно отсортировать массив всеми способами");
            }
            else
            {
                Diagram wnd = new Diagram(sortClass.linearTime.ElapsedTicks, sortClass.minMaxTime.ElapsedTicks, sortClass.bubleTime.ElapsedTicks, sortClass.shuttleTime.ElapsedTicks, sortClass.insertionTime.ElapsedTicks);
                wnd.Show();
            }
        }
    }
}
