﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SORTER
{
    public class sortClass
    {
        public static Stopwatch linearTime;
        public static Stopwatch minMaxTime;
        public static Stopwatch bubleTime;
        public static Stopwatch shuttleTime;
        public static Stopwatch insertionTime;

        public static int[] linearSelectionSort(bool? ordering, int[] arrayCopy)
        {
            int[] arraySorted = new int[arrayCopy.Length];

            int max = int.MinValue;
            int min = int.MaxValue;
            int index = 0;
            int count;

            linearTime = new Stopwatch();
            linearTime.Start();

            if (ordering == false)
            {
                count = 0;
                while (count < arrayCopy.Length)
                {
                    for (int i = 0; i < arrayCopy.Length; ++i)
                    {
                        if (max <= arrayCopy[i] && arrayCopy[i] != 100)
                        {
                            max = arrayCopy[i];
                            index = i;
                        }
                    }
                    arrayCopy[index] = 100;
                    arraySorted[count] = max;
                    count++;
                    max = int.MinValue;
                }
            }
            else
            {
                count = 0;
                while (count < arrayCopy.Length)
                {
                    for (int i = 0; i < arrayCopy.Length; ++i)
                    {
                        if (min >= arrayCopy[i] && arrayCopy[i] != 100)
                        {
                            min = arrayCopy[i];
                            index = i;
                        }
                    }
                    arrayCopy[index] = 100;
                    arraySorted[count] = min;
                    count++;
                    min = int.MaxValue;
                }
            }

            linearTime.Stop();
            return arraySorted;
        }


        public static int[] methodMinMax(bool? ordering, int[] arrayCopy)
        {

            minMaxTime = new Stopwatch();
            minMaxTime.Start();

            if (ordering == false)
            {
                for (int i = 0; i < arrayCopy.Length - 1; ++i)
                {
                    int max = i;

                    for (int j = i + 1; j < arrayCopy.Length; ++j)
                    {
                        if (arrayCopy[j].CompareTo(arrayCopy[max]) > 0)
                        {
                            max = j;
                        }
                    }

                    int temp = arrayCopy[i];
                    arrayCopy[i] = arrayCopy[max];
                    arrayCopy[max] = temp;
                }

            }
            else
            {
                for (int i = 0; i < arrayCopy.Length - 1; ++i)
                {
                    int max = i;

                    for (int j = i + 1; j < arrayCopy.Length; ++j)
                    {
                        if (arrayCopy[j].CompareTo(arrayCopy[max]) < 0)
                        {
                            max = j;
                        }
                    }

                    int temp = arrayCopy[i];
                    arrayCopy[i] = arrayCopy[max];
                    arrayCopy[max] = temp;
                }

            }

            minMaxTime.Stop();
            return arrayCopy;
        }


        public static int[] BubbleSort(bool? ordering, int[] arrayCopy)
        {

            int temp;

            bubleTime = new Stopwatch();
            bubleTime.Start();

            if (ordering == false)
            {
                for (int i = 0; i < arrayCopy.Length - 1; i++)
                {
                    for (int j = 0; j < arrayCopy.Length - i - 1; j++)
                    {
                        if (arrayCopy[j + 1] > arrayCopy[j])
                        {
                            temp = arrayCopy[j + 1];
                            arrayCopy[j + 1] = arrayCopy[j];
                            arrayCopy[j] = temp;
                        }
                    }
                }
            }
            else
            {
                for (int i = 0; i < arrayCopy.Length - 1; i++)
                {
                    for (int j = 0; j < arrayCopy.Length - i - 1; j++)
                    {
                        if (arrayCopy[j + 1] < arrayCopy[j])
                        {
                            temp = arrayCopy[j + 1];
                            arrayCopy[j + 1] = arrayCopy[j];
                            arrayCopy[j] = temp;
                        }
                    }
                }
            }

            bubleTime.Stop();
            return arrayCopy;
        }


        public static int[] ShuttleSort(bool? ordering, int[] arrayCopy)
        {
            int temp;

            shuttleTime = new Stopwatch();
            shuttleTime.Start();

            if (ordering == false)
            {
                for (int i = 1; i < arrayCopy.Length; i++)
                {
                    if (arrayCopy[i] > arrayCopy[i - 1])
                    {
                        temp = arrayCopy[i];
                        arrayCopy[i] = arrayCopy[i - 1];
                        arrayCopy[i - 1] = temp;
                        for (int j = i - 1; (j - 1) >= 0; j--)
                        {
                            if (arrayCopy[j] > arrayCopy[j - 1])
                            {
                                temp = arrayCopy[j];
                                arrayCopy[j] = arrayCopy[j - 1];
                                arrayCopy[j - 1] = temp;
                            }
                            else
                            {
                                break;
                            }
                        }
                    }
                }
            }
            else
            {
                for (int i = 1; i < arrayCopy.Length; i++)
                {
                    if (arrayCopy[i] < arrayCopy[i - 1])
                    {
                        temp = arrayCopy[i];
                        arrayCopy[i] = arrayCopy[i - 1];
                        arrayCopy[i - 1] = temp;
                        for (int j = i - 1; (j - 1) >= 0; j--)
                        {
                            if (arrayCopy[j] < arrayCopy[j - 1])
                            {
                                temp = arrayCopy[j];
                                arrayCopy[j] = arrayCopy[j - 1];
                                arrayCopy[j - 1] = temp;
                            }
                            else
                            {
                                break;
                            }
                        }
                    }
                }
            }

            shuttleTime.Stop();
            return arrayCopy;
        }


        public static int[] InsertionSort(bool? ordering, int[] arrayCopy)
        {

            int index, temp;

            insertionTime = new Stopwatch();
            insertionTime.Start();

            if (ordering == false)
            {
                for (int i = 0; i < arrayCopy.Length; ++i)
                {
                    index = i;
                    temp = arrayCopy[i];
                    for (int j = i + 1; j < arrayCopy.Length; ++j)
                    {
                        if (arrayCopy[j] > temp)
                        {
                            index = j;
                            temp = arrayCopy[j];
                        }
                    }
                    arrayCopy[index] = arrayCopy[i];
                    arrayCopy[i] = temp;
                }
            }
            else
            {
                for (int i = 0; i < arrayCopy.Length; ++i)
                {
                    index = i;
                    temp = arrayCopy[i];
                    for (int j = i + 1; j < arrayCopy.Length; ++j)
                    {
                        if (arrayCopy[j] < temp)
                        {
                            index = j;
                            temp = arrayCopy[j];
                        }
                    }
                    arrayCopy[index] = arrayCopy[i];
                    arrayCopy[i] = temp;
                }
            }

            insertionTime.Stop();
            return arrayCopy;
        }
    }
}
