using Microsoft.VisualStudio.TestTools.UnitTesting;
using SORTER;
using System.Linq;

namespace TestSorter
{
    [TestClass]
    public class UnitTest1
    {

        [TestMethod]
        public void TestLinear ()
        {
            int[] arrayAsc = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
            int[] arrayUnSortedAsc = { 2, 1, 3, 4, 8, 5, 10, 7, 9, 6 };
            int[] arraySortedAsc = sortClass.linearSelectionSort(true, arrayUnSortedAsc);
            Assert.IsTrue(arrayAsc.SequenceEqual(arraySortedAsc));


            int[] arrayDesc = { 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
            int[] arrayUnSortedDesc = { 2, 1, 3, 4, 8, 5, 10, 7, 9, 6 };
            int[] arraySortedDesc = sortClass.linearSelectionSort(false, arrayUnSortedDesc);
            Assert.IsTrue(arrayDesc.SequenceEqual(arraySortedDesc));
        }


        [TestMethod]
        public void TestMinMax()
        {
            int[] arrayAsc = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
            int[] arrayUnSortedAsc = { 2, 1, 3, 4, 8, 5, 10, 7, 9, 6 };
            int[] arraySortedAsc = sortClass.methodMinMax(true, arrayUnSortedAsc);
            Assert.IsTrue(arrayAsc.SequenceEqual(arraySortedAsc));


            int[] arrayDesc = { 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
            int[] arrayUnSortedDesc = { 2, 1, 3, 4, 8, 5, 10, 7, 9, 6 };
            int[] arraySortedDesc = sortClass.methodMinMax(false, arrayUnSortedDesc);
            Assert.IsTrue(arrayDesc.SequenceEqual(arraySortedDesc));
        }


        [TestMethod]
        public void TestBubble()
        {
            int[] arrayAsc = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
            int[] arrayUnSortedAsc = { 2, 1, 3, 4, 8, 5, 10, 7, 9, 6 };
            int[] arraySortedAsc = sortClass.BubbleSort(true, arrayUnSortedAsc);
            Assert.IsTrue(arrayAsc.SequenceEqual(arraySortedAsc));


            int[] arrayDesc = { 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
            int[] arrayUnSortedDesc = { 2, 1, 3, 4, 8, 5, 10, 7, 9, 6 };
            int[] arraySortedDesc = sortClass.BubbleSort(false, arrayUnSortedDesc);
            Assert.IsTrue(arrayDesc.SequenceEqual(arraySortedDesc));
        }


        [TestMethod]
        public void TestShuttle()
        {
            int[] arrayAsc = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
            int[] arrayUnSortedAsc = { 2, 1, 3, 4, 8, 5, 10, 7, 9, 6 };
            int[] arraySortedAsc = sortClass.ShuttleSort(true, arrayUnSortedAsc);
            Assert.IsTrue(arrayAsc.SequenceEqual(arraySortedAsc));


            int[] arrayDesc = { 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
            int[] arrayUnSortedDesc = { 2, 1, 3, 4, 8, 5, 10, 7, 9, 6 };
            int[] arraySortedDesc = sortClass.ShuttleSort(false, arrayUnSortedDesc);
            Assert.IsTrue(arrayDesc.SequenceEqual(arraySortedDesc));
        }


        [TestMethod]
        public void TestInsertion()
        {
            int[] arrayAsc = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
            int[] arrayUnSortedAsc = { 2, 1, 3, 4, 8, 5, 10, 7, 9, 6 };
            int[] arraySortedAsc = sortClass.InsertionSort(true, arrayUnSortedAsc);
            Assert.IsTrue(arrayAsc.SequenceEqual(arraySortedAsc));


            int[] arrayDesc = { 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
            int[] arrayUnSortedDesc = { 2, 1, 3, 4, 8, 5, 10, 7, 9, 6 };
            int[] arraySortedDesc = sortClass.InsertionSort(false, arrayUnSortedDesc);
            Assert.IsTrue(arrayDesc.SequenceEqual(arraySortedDesc));
        }
    }
}